// DialogConfigTab6.cpp : @
//

#include "stdafx.h"
#include "VTC1021_Utility.h"
#include "DialogConfigTab6.h"
#include "VTC1021.h"


CDialogConfigTab6 *g_pCDialogConfigTab6 = NULL;

BOOL isBackupBatteryAlarm = FALSE;
void BackupBatteryAlarm(unsigned char byAlarm)
{
	isBackupBatteryAlarm = TRUE;

	if( byAlarm == 0x01 )
		g_pCDialogConfigTab6->m_CEdit_BatteryAlarm.SetWindowText("Low battery");
	if( byAlarm == 0x02 )
		g_pCDialogConfigTab6->m_CEdit_BatteryAlarm.SetWindowText("Over Temperature");
	if( byAlarm == 0x03 )
		g_pCDialogConfigTab6->m_CEdit_BatteryAlarm.SetWindowText("Low battery & Over Temperature");

	g_pCDialogConfigTab6->m_CEdit_BatteryAlarm.ShowWindow(SW_SHOW);
	g_pCDialogConfigTab6->m_CEdit_BatteryStatus.ShowWindow(SW_HIDE);
	g_pCDialogConfigTab6->m_CButton_ClearAlarm.ShowWindow(SW_SHOW);
}


// CDialogConfigTab6 ܤ

IMPLEMENT_DYNAMIC(CDialogConfigTab6, CDialog)

CDialogConfigTab6::CDialogConfigTab6(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogConfigTab6::IDD, pParent)
{
	m_isDoCommand = FALSE;
}

CDialogConfigTab6::~CDialogConfigTab6()
{
}

void CDialogConfigTab6::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_CEdit_BatteryStatus);
	DDX_Control(pDX, IDC_EDIT2, m_CEdit_SmartBatteryVoltage);
	DDX_Control(pDX, IDC_EDIT3, m_CEdit_SmartBatteryTemperature);
	DDX_Control(pDX, IDC_EDIT4, m_CEdit_SmartBatteryCapacity);
	DDX_Control(pDX, IDC_EDIT5, m_CEdit_BatteryAlarm);
	DDX_Control(pDX, IDC_BUTTON2, m_CButton_ClearAlarm);
}


BEGIN_MESSAGE_MAP(CDialogConfigTab6, CDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, &CDialogConfigTab6::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CDialogConfigTab6::OnBnClickedButton2)
	ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


// CDialogConfigTab6 TBz`

BOOL CDialogConfigTab6::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here

	m_CEdit_BatteryAlarm.SetWindowText("Low battery");
	m_CEdit_BatteryAlarm.ShowWindow(SW_HIDE);

	m_CButton_ClearAlarm.ShowWindow(SW_HIDE);

	g_pCDialogConfigTab6 = this;
	RegisterBatteryCallBackFunction(BackupBatteryAlarm);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDialogConfigTab6::OnTimer(UINT_PTR nIDEvent)
{
	if( 1 == nIDEvent )
	{
		KillTimer(1);

		switch( m_nStep )
		{
		case 0:  fnGetBackupBatteryStatus();		m_nStep++; break;
		case 1:  fnGetSmartBatteryVoltage();		m_nStep++; break;
		case 2:  fnGetSmartBatteryTemperature();	m_nStep++; break;
		case 3:  fnGetSmartBatteryCapacity();		m_nStep++; break;
		default: break;
		}

		if( m_nStep < 4 )
			SetTimer(1, 100, NULL);
	}

	if( 2 == nIDEvent )
	{
		KillTimer(2);

		if( IsWindowVisible() )
		{
			static unsigned int nBatteryCount = 0;

			switch(nBatteryCount%4)
			{
			case 0: fnGetBackupBatteryStatus();		break;
			case 1: fnGetSmartBatteryVoltage();		break;
			case 2: fnGetSmartBatteryTemperature();	break;
			case 3: fnGetSmartBatteryCapacity();	break;
			}

			nBatteryCount++;
		}

		SetTimer(2, 200, NULL);
	}

	CDialog::OnTimer(nIDEvent);
}

void CDialogConfigTab6::OnBnClickedButton1()
{
	fnUpdate();
}

void CDialogConfigTab6::OnBnClickedButton2()
{
	isBackupBatteryAlarm = FALSE;
	m_CEdit_BatteryAlarm.ShowWindow(SW_HIDE);
	m_CEdit_BatteryStatus.ShowWindow(SW_SHOW);
	m_CButton_ClearAlarm.ShowWindow(SW_HIDE);
	fnGetBackupBatteryStatus();
}

HBRUSH CDialogConfigTab6::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if (pWnd->GetDlgCtrlID() == IDC_EDIT5) // replace with your ID
	{
		pDC->SetTextColor(RGB(255,0,0)); // change to what you want
	}

	return hbr;
}

void CDialogConfigTab6::fnGetBackupBatteryStatus()
{
	if ( TRUE == isBackupBatteryAlarm )
	{
		return;
	}

	int nBatteryStatus = 0;
	int nResult = GetBackupBatteryStatus(&nBatteryStatus);
	if( nResult == 1 )
	{
		CString strBatteryStatus;
		switch(nBatteryStatus)
		{
		case 0: strBatteryStatus = TEXT("N/A"); break;
		case 1: strBatteryStatus = TEXT("Charge Finish."); break;
		case 2: strBatteryStatus = TEXT("Charge Now."); break;
		case 3: strBatteryStatus = TEXT("Discharge Now."); break;
		case 4: strBatteryStatus = TEXT("Charge Stop."); break;
		default: strBatteryStatus = TEXT("Undefined"); break;
		}
		m_CEdit_BatteryStatus.SetWindowText(strBatteryStatus);
	}
	else
	{
		m_CEdit_BatteryStatus.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab6::fnGetSmartBatteryVoltage()
{
	int nSmartBatteryVoltage = 0;
	int nResult = GetSmartBatteryVoltage(&nSmartBatteryVoltage);
	if( nResult == 1 )
	{
		double fVoltage = (double)nSmartBatteryVoltage/1000;
		CString strSmartBatteryVoltage;
		strSmartBatteryVoltage.Format(TEXT("%2.1f V"), fVoltage);
		m_CEdit_SmartBatteryVoltage.SetWindowText(strSmartBatteryVoltage);
	}
	else
	{
		m_CEdit_SmartBatteryVoltage.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab6::fnGetSmartBatteryTemperature()
{
	int nBatteryTemperature = 0;
	int nResult = GetSmartBatteryTemperature(&nBatteryTemperature);
	if( nResult == 1 )
	{
		WCHAR szBatteryTemperature[32];
		swprintf(szBatteryTemperature, 32, L"%d\u00B0C", nBatteryTemperature);
		::SetWindowTextW(m_CEdit_SmartBatteryTemperature.GetSafeHwnd(), szBatteryTemperature);
	}
	else
	{
		m_CEdit_SmartBatteryTemperature.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab6::fnGetSmartBatteryCapacity()
{
	int nBatteryCapacity = 0;
	int nResult = GetSmartBatteryCapacity(&nBatteryCapacity);
	if( nResult == 1 )
	{
		CString strBatteryCapacity;
		strBatteryCapacity.Format(TEXT("%d"), nBatteryCapacity); 
		m_CEdit_SmartBatteryCapacity.SetWindowText(strBatteryCapacity);
	}
	else
	{
		m_CEdit_SmartBatteryCapacity.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab6::fnUpdate()
{
	fnGetBackupBatteryStatus();
	fnGetSmartBatteryVoltage();
	fnGetSmartBatteryTemperature();
	fnGetSmartBatteryCapacity();
}

void CDialogConfigTab6::DoCommand()
{
	if( FALSE == m_isDoCommand )
	{
		m_isDoCommand = TRUE;
		m_nStep = 0;
		SetTimer(1, 0, NULL);
	}

	SetTimer(2, 500, NULL);
}
